print("1. Prise en main")
print("hello world")

print("")
print("2. Variables")
x = 1
s = "bla"
x = 3 - x
print(s + "s")
print(3 * x + 4)

x = 4
s = "3"
print(int(s) + x)
print(s + str(x))

print("")
print("3. Les blocs par l'indentation")

n, m = 0, 42
if n == 0:
    n = 1
    if m == 0:
        m = 2 * n
    else:
        m = n - 1  # This line is executed iff n == 0 and m != 0
print(n, m)

n, m = 0, 0
if n == 0:
    n = 1
    if m == 0:
        m = 2 * n
else:
    m = n - 1  # This line is executed iff n != 0
print(n, m)

print("")
print("4. Premières fonctions")


def carree(n):
    return n * n


print(carree(4))


def f(n, m):
    """Toy function.

    :param n: An integer.
    :param m: An integer.

    :return:  A string. "pair" iff max(n, m) is even, "impair" iff max(n, m)
    is odd.
    """
    s = "pair"
    if n < m:
        if m % 2 == 0:
            return s
        else:
            return "im" + s
    else:
        if n % 2 == 0:
            return s
        else:
            return "im" + s


print("")
print("Exercice 1")


def factorial_it(n):
    """Factorial (iterative implementation).

    :param n: A nonnegative integer.

    :return: The factorial of n.
    """
    result = 1
    for i in range(2, n + 1):
        result *= i
    return result


n_test = 6
print("n_test = ", n_test)
print("factorial_it(n_test) = ", factorial_it(n_test))

print("")
print("Exercice 2")


def factorial_rec(n):
    """Factorial (recursive implementation).

    :param n: A nonnegative integer.

    :return: The factorial of n.
    """
    if n == 0:
        return 1
    return factorial_rec(n - 1) * n


print("n_test = ", n_test)
print("factorial_rec(n_test) = ", factorial_rec(n_test))

print("")
print("Exercice 3")


def power_it(a, n):
    """Exponentiation (iterative implementation).

    :param a: A number.
    :param n: A nonnegative integer.

    :return: a to the power n.
    """
    result = 1
    for i in range(n):
        result *= a
    return result


a_test = 2
n_test = 10
print("a_test = ", a_test)
print("n_test = ", n_test)
print("power_it(a_test, n_test) = ", power_it(a_test, n_test))

print("")
print("Exercice 4")


def power_rec(a, n):
    """Exponentiation (recursive implementation).

    :param a: A number.
    :param n: A nonnegative integer.

    :return: a to the power n.
    """
    if n == 0:
        return 1
    return power_rec(a, n - 1) * a


a_test = 2
n_test = 10
print("a_test = ", a_test)
print("n_test = ", n_test)
print("power_rec(a_test, n_test) = ", power_rec(a_test, n_test))

print("")
print("Exercice 5")


def power_rec_smart(a, n):
    """Exponentiation ('divide and conquer' recursive implementation).

    :param a: A number.
    :param n: A nonnegative integer.

    :return: a to the power n.
    """
    if n == 0:
        return 1
    temp = power_rec_smart(a, n // 2)
    if n % 2 == 0:
        return temp * temp
    else:
        return temp * temp * a


a_test = 2
n_test = 10
print("a_test = ", a_test)
print("n_test = ", n_test)
print("power_rec_smart(a_test, n_test) = ", power_rec_smart(a_test, n_test))

# La version améliorée de l'algorithme réalise O(log(n)) multiplications.